import React, { createContext, useState, useEffect, useContext } from 'react';

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}

var webGuideContext = createContext();
var WebGuide = function WebGuide(_ref) {
  var _ref$active = _ref.active,
    active = _ref$active === void 0 ? true : _ref$active,
    step = _ref.step,
    _ref$defaultStep = _ref.defaultStep,
    defaultStep = _ref$defaultStep === void 0 ? 0 : _ref$defaultStep,
    data = _ref.data,
    _ref$GuideDialogProps = _ref.GuideDialogProps,
    GuideDialogProps = _ref$GuideDialogProps === void 0 ? {
      gap: '0px',
      padding: '0px',
      isSmooth: true,
      background: '#ffffff',
      styleOuter: {
        background: 'rgba(0,0,0,0.5)'
      }
    } : _ref$GuideDialogProps,
    _ref$customGuideDialo = _ref.customGuideDialog,
    customGuideDialog = _ref$customGuideDialo === void 0 ? null : _ref$customGuideDialo,
    onCompleteGuide = _ref.onCompleteGuide;
  var _useState = useState(defaultStep),
    mainStep = _useState[0],
    setMainStep = _useState[1];
  var _useState2 = useState(null),
    bodyInfo = _useState2[0],
    setBodyInfo = _useState2[1];
  var _useState3 = useState(null),
    stepRect = _useState3[0],
    setStepRect = _useState3[1];
  useEffect(function () {
    if (defaultStep) {
      setMainStep(defaultStep);
      handleGetStepInfo(defaultStep);
    } else {
      handleGetStepInfo(mainStep);
    }
    var bodyRect = document.body.getBoundingClientRect();
    setBodyInfo(bodyRect);
  }, []);
  useEffect(function () {
    if (step) {
      setMainStep(step);
    }
  }, [step]);
  var handleChangeStep = function handleChangeStep(isForward) {
    if (isForward === void 0) {
      isForward = true;
    }
    var newStep = mainStep + (isForward ? 1 : -1);
    if (newStep === data.length) {
      onCompleteGuide && onCompleteGuide();
    } else if (newStep >= 0) {
      handleGetStepInfo(newStep);
      setMainStep(newStep);
    }
  };
  var handleGetStepInfo = function handleGetStepInfo(_step) {
    var element = document.getElementById(data[_step].id);
    element.scrollIntoView({
      behavior: 'smooth',
      block: 'center',
      inline: 'center'
    });
    var rect = element.getBoundingClientRect();
    setStepRect(rect);
  };
  return active && bodyInfo && /*#__PURE__*/React.createElement(webGuideContext.Provider, {
    value: {
      GuideDialogProps: GuideDialogProps,
      customGuideDialog: customGuideDialog,
      data: data,
      step: mainStep
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      position: 'absolute',
      width: '100%',
      left: 0,
      top: 0,
      height: bodyInfo === null || bodyInfo === void 0 ? void 0 : bodyInfo.height,
      display: 'flex',
      flexDirection: 'column'
    }
  }, /*#__PURE__*/React.createElement(CoverArea, {
    minHeight: "calc(" + (stepRect.top + window.pageYOffset) + "px - " + ((GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.padding) || '0px') + ")"
  }), /*#__PURE__*/React.createElement("div", {
    style: {
      width: '100%',
      display: 'flex',
      transition: (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.isSmooth) && 'ease 0.5s'
    }
  }, /*#__PURE__*/React.createElement(CoverArea, {
    minWidth: "calc(" + stepRect.left + "px - " + ((GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.padding) || '0px') + ")"
  }), /*#__PURE__*/React.createElement("div", {
    style: {
      transition: (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.isSmooth) && 'ease 0.5s',
      minWidth: stepRect.width,
      height: stepRect.height,
      position: 'relative',
      padding: (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.padding) || '0px',
      transformOrigin: 'center',
      border: '1px solid #fff'
    }
  }, /*#__PURE__*/React.createElement(DescArea, {
    onStepChange: handleChangeStep
  })), /*#__PURE__*/React.createElement(CoverArea, {
    width: "100%"
  })), /*#__PURE__*/React.createElement(CoverArea, {
    height: "100%"
  })));
};
function CoverArea(_ref2) {
  var width = _ref2.width,
    minWidth = _ref2.minWidth,
    height = _ref2.height,
    minHeight = _ref2.minHeight;
  var _useContext = useContext(webGuideContext),
    GuideDialogProps = _useContext.GuideDialogProps;
  return /*#__PURE__*/React.createElement("div", {
    style: _extends({
      width: width,
      minWidth: minWidth,
      height: height,
      minHeight: minHeight,
      background: 'rgba(0,0,0,0.5)',
      display: 'flex',
      transition: (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.isSmooth) && 'ease 0.5s'
    }, GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.styleOuter)
  });
}
function DescArea(_ref3) {
  var onStepChange = _ref3.onStepChange;
  var _useContext2 = useContext(webGuideContext),
    GuideDialogProps = _useContext2.GuideDialogProps,
    data = _useContext2.data,
    step = _useContext2.step,
    customGuideDialog = _useContext2.customGuideDialog;
  var _data$step = data[step],
    position = _data$step.position,
    description = _data$step.description;
  var Icon = null;
  var styles = {
    position: 'absolute',
    background: (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.background) || '#fff',
    transition: (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.isSmooth) && 'ease 0.5s',
    zIndex: 1000
  };
  var posPart = position.split(' ');
  if (posPart[0] === 'top') {
    Icon = /*#__PURE__*/React.createElement("div", {
      style: {
        position: 'absolute',
        top: 'calc(100% - 8px)'
      }
    }, /*#__PURE__*/React.createElement(ArrowDown, {
      color: (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.background) || '#ffffff'
    }));
    styles = _extends({}, styles, {
      bottom: "calc(100% + " + (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.gap),
      left: posPart[1] === undefined ? '50%' : posPart[1] === 'start' && 0,
      right: posPart[1] === 'end' && 0,
      transform: posPart[1] === undefined && 'translateX(-50%)'
    });
  } else if (posPart[0] === 'bottom') {
    Icon = /*#__PURE__*/React.createElement("div", {
      style: {
        position: 'absolute',
        bottom: 'calc(100% - 8px)'
      }
    }, /*#__PURE__*/React.createElement(ArrowUp, {
      color: (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.background) || '#ffffff'
    }));
    styles = _extends({}, styles, {
      top: "calc(100% + " + (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.gap),
      left: posPart[1] === undefined ? '50%' : posPart[1] === 'start' && 0,
      right: posPart[1] === 'end' && 0,
      transform: posPart[1] === undefined && 'translateX(-50%)'
    });
  } else if (posPart[0] === 'right') {
    Icon = /*#__PURE__*/React.createElement("div", {
      style: {
        position: 'absolute',
        right: 'calc(100% - 5px)'
      }
    }, /*#__PURE__*/React.createElement(ArrowLeft, {
      color: (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.background) || '#ffffff'
    }));
    styles = _extends({}, styles, {
      left: "calc(100% + " + (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.gap),
      top: posPart[1] === undefined ? '50%' : posPart[1] === 'start' && 0,
      bottom: posPart[1] === 'end' && 0,
      transform: posPart[1] === undefined && 'translateY(-50%)'
    });
  } else if (posPart[0] === 'left') {
    Icon = /*#__PURE__*/React.createElement("div", {
      style: {
        position: 'absolute',
        left: 'calc(100% - 5px)'
      }
    }, /*#__PURE__*/React.createElement(ArrowRight, {
      color: (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.background) || '#ffffff'
    }));
    styles = _extends({}, styles, {
      right: "calc(100% + " + (GuideDialogProps === null || GuideDialogProps === void 0 ? void 0 : GuideDialogProps.gap) + ")",
      top: posPart[1] === undefined ? '50%' : posPart[1] === 'start' && 0,
      bottom: posPart[1] === 'end' && 0,
      transform: posPart[1] === undefined && 'translateY(-50%)'
    });
  }
  return /*#__PURE__*/React.createElement("div", {
    style: styles
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      position: 'relative',
      display: 'flex',
      flexDirection: 'column',
      gap: '20px',
      padding: '10px'
    }
  }, Icon, customGuideDialog !== null ? customGuideDialog(data[step]) : /*#__PURE__*/React.createElement("div", null, description, /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      gap: '20px'
    }
  }, /*#__PURE__*/React.createElement("button", {
    disabled: step === 0,
    onClick: function onClick() {
      return onStepChange(false);
    }
  }, /*#__PURE__*/React.createElement(ArrowLeft, null)), step + 1 + "/" + data.length, /*#__PURE__*/React.createElement("button", {
    disabled: step === data.length - 1,
    onClick: function onClick() {
      return onStepChange(true);
    }
  }, /*#__PURE__*/React.createElement(ArrowRight, null))))));
}
function ArrowRight(_ref4) {
  var color = _ref4.color;
  return /*#__PURE__*/React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "16",
    height: "16",
    fill: color,
    "class": "bi bi-caret-right-fill",
    viewBox: "0 0 16 16"
  }, /*#__PURE__*/React.createElement("path", {
    d: "m12.14 8.753-5.482 4.796c-.646.566-1.658.106-1.658-.753V3.204a1 1 0 0 1 1.659-.753l5.48 4.796a1 1 0 0 1 0 1.506z"
  }));
}
function ArrowLeft(_ref5) {
  var color = _ref5.color;
  return /*#__PURE__*/React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "16",
    height: "16",
    fill: color,
    "class": "bi bi-caret-left-fill",
    viewBox: "0 0 16 16"
  }, /*#__PURE__*/React.createElement("path", {
    d: "m3.86 8.753 5.482 4.796c.646.566 1.658.106 1.658-.753V3.204a1 1 0 0 0-1.659-.753l-5.48 4.796a1 1 0 0 0 0 1.506z"
  }));
}
function ArrowUp(_ref6) {
  var color = _ref6.color;
  return /*#__PURE__*/React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "16",
    height: "16",
    fill: color,
    "class": "bi bi-caret-up-fill",
    viewBox: "0 0 16 16"
  }, /*#__PURE__*/React.createElement("path", {
    d: "m7.247 4.86-4.796 5.481c-.566.647-.106 1.659.753 1.659h9.592a1 1 0 0 0 .753-1.659l-4.796-5.48a1 1 0 0 0-1.506 0z"
  }));
}
function ArrowDown(_ref7) {
  var color = _ref7.color;
  return /*#__PURE__*/React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "16",
    height: "16",
    fill: color,
    "class": "bi bi-caret-down-fill",
    viewBox: "0 0 16 16"
  }, /*#__PURE__*/React.createElement("path", {
    d: "M7.247 11.14 2.451 5.658C1.885 5.013 2.345 4 3.204 4h9.592a1 1 0 0 1 .753 1.659l-4.796 5.48a1 1 0 0 1-1.506 0z"
  }));
}

export { WebGuide };
//# sourceMappingURL=index.modern.js.map
